#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/wait.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>

#define N 1000

int main(int argc, char **argv) {
    size_t size;
    char *buf;

    size=strtoul(argv[1], NULL, 0);
    if ((buf = calloc(size, 1)) == NULL) {
	fprintf(stderr, "%s: cannot malloc %lu bytes: %s\n",
	        argv[0], (unsigned long)size, strerror(errno));
	exit(1);
    }
    struct timeval t0;
    gettimeofday(&t0, NULL);
    for (int i = 0; i < N; i++) {
	int pid;
	switch(pid = fork()) {
	    case -1:
		fprintf(stderr, "%s: cannot fork: %s\n",
			argv[0], strerror(errno));
		exit(1);
	    case 0:
		// child
		exit(0);
	    default:
		while (waitpid(pid, NULL, 0) == -1) {};
	}
    }
    struct timeval t1;
    gettimeofday(&t1, NULL);
    printf("%lu bytes %ld us/fork\n",
	    (unsigned long)size,
           ((t1.tv_sec - t0.tv_sec) * 1000000 + (t1.tv_usec - t0.tv_usec)) / N);
    return 0;
}
